# Compte rendu analyse du ticket 1023

## 1. Le ticket

Ticket décrit dans la page https://git.scodoc.org/Scodoc/Scodoc/issues/1023



Proposition de collègue:

L'envoi de mail en cas d absences trop nombreuses est bien utilisé mais présentes quelques petits défauts:
le mail part à après la saisie de l absence mais la justification peut arriver (selon notre réglement des études) dans les trois jours qui suivent. Cela provoque donc quelques faux positifs
Certains directeurs d'étude traitent les absence selon un rithme régulier (semaine/mois). il leur faut donc reprendre l'histoques des mails qui peuvent être nombreux (surtout en première année)

proposition:
remplacer l'envoi immédiat par un envoi régulier (hebdomadaire, mensuel) d'une compilation des alertes du mois. les absences injustifiées des étudiants qui ont eu plus de x absences injustifiées depuis le début du semestre.


## 2. Analyse du ticket 

Classification : On peut considérer le ticket comme une maintenance **corrective** ou
**évolutive**.

Nous classiferions comme évolutive, car la fonctionnalité fonctionnait mais ne correspondait pas totalement au besoin.

## 2.1 Reproduire le problème

Etudiant : Valentin FEBLAR

Classe email avec méthode _send-message_ -> /app/email.py

Utilisation de la classe email pour les absences -> app/scodoc/sco_abs_notification.py

Classe assiduites.py -> app/models/assiduites.py
    appelle la méthode _create-assiduite_
        qui lui va appeler sco_abs_notifaction.abs_notify
            qui lui va appeler do_abs_notify
                qui lui va appeler abs_notify_send  
                    qui lui va appeler email.send_message

test avec les log et tout -> problème à partir de l'appel du abs_notify_send dans le abs_notify => invalid_formsemestre

for destinations -> vide car à la création le abs_notify_get_destinations possède un formsemestre invalide 

Problème trouvé -> voir screen fait 

## 2.2 Analyse de la solution

- Dans la classe app/api/billets_absences.py se trouve une méthode billets_absence_etudiant qui renvoie la liste des absences d'un étudiant donné 

- Gestion des absences dans la bases de données se déroule dans la classe app/models/absences.py -> dedans il crée une classe BilletAbsence

- classe app/api/assiduites.py contient une méthode assiduites qui retourne la liste des absences d'un étudiant  

- classe app/models/assiduites.py contient une méthode get_assiduite qui retourne la liste des assiduités pour un dept 

- classe CountCalculator dans le fichier app/scodoc/sco_assiduites.py TRES INTERESSANTE 

- Voir photo avec tableau par groupe et période de toutes les absences d'un groupe, création du fichier dans la classe app/views/assiduites.py -> méthode visu_asssi_group()

- ON AIMES LA CLASSE TableAsssi dans le fichier app/tables/visu_assiduites.py (utilise la clase CountCalculator)

- méthode est_courant dans app/models/formesemestre.py qui permet de savoir si la période d'un semestre est compris dans la date actuelle

- méthode groups_table dans app/scodoc/sco_groups_view.py qui retourne la liste des étudiants dans un semestre 

- méthode get_default_group dans app/scodoc/sco_groups.py qui retourne les groupes d'un formsemester

- méthode _get_etud_stats dans app/tables/visu_assiduites.py qui retoune le nombre absences et nbr absences justifiées

- méthode get_assiduites_stats dans app/scodoc/sco_assiduites.py qui permet de récuperer les assiduites d'un etudiant pour une periode donnée

- méthode _list_formsemestres_query dans app/api/formesemestre.py qui permet de récupérer les formesemestre

Première étape : récuperer la liste de tout les semestres 
    - méthode _list_formsemestres_query dans app/api/formesemestre.py qui permet de récupérer les formesemestre
Deuxième étape : faire une boucle sur la liste des semestres et leur appliqué la méthode est_courant (ne garder que ceux qui retourne true)
    - méthode est_courant dans app/models/formesemestre.py qui permet de savoir si la période d'un semestre est compris dans la date actuelle
Troisième étape : récupérer la liste d'étudiants (à partir du formsemestre)
    - méthode groups_table dans app/scodoc/sco_groups_view.py qui retourne la liste des étudiants dans un semestre 
Quatrième étape : Récuperer les absences par étudiant
    - méthode get_default_group dans app/scodoc/sco_groups.py qui retourne les groupes d'un formsemester
    - création d'un objet TableAssi dans le fichier app/tables/visu_assiduites.py ( qui utilise la clase CountCalculator)
    - méthode _get_etud_stats dans app/tables/visu_assiduites.py qui retoune le nombre absences et nbr absences justifiées
Cinquième étape : Pour les étudiants pré sélectionné, on récuoère leurs absences du mois dernier
    - méthode get_assiduites_stats dans app/scodoc/sco_assiduites.py qui permet de récuperer les assiduites d'un etudiant pour une periode donnée


## 2.3 Proposition de la solution 

Création d'un scheduler/workflow qui va lancer chaque mois, une méthode qui va générer et envoyer un mail à chaque étudiants qui ont plus de x absences injustifiées dans le semestre, résumant leurs absences injustifiées du mois précedent. 

Création du scheduler : 

- Utilisation du module python apsscheduler : 

    from apsscheduler.schedulers.background import BackGroundScheduler

- Création d'une méthode pour instancier notre scheduler et le lancer : 

    code

- On va appeler le scheduler pour lancer l'execution en arrière plan, avec le lancement de l'app en premier lan

    code

- Implémenter le job que le scheduler va lancer (envoie mail)

    code

- Paramétrer le scheduler (fréquence execution)

    code 


Suppression ancien mail : 

-   Trouver sa place dans le code

    code

- Retirer l'envoie immédiat 



